/*
 * Proyecto Final: Estructura de Datos
 * Diccionario
 * JACE - JDSM - ADUA - AAVJ
 */
package Vista;

import Controlador.dao.PalabraDao;
import Controladores.ControladorEjemplo;
import Controladores.ControladorIdiomas;
import Controladores.ControladorSinonimos;
import Modelo.enums.Idiomas;
import Modelo.enums.SiglasIdiomas;
import Vista.ModeloTabla.ModeloTablaModificarPalabra;
import Vista.ModeloTabla.ModeloTablaModificarPalabraEjemplos;
import Vista.ModeloTabla.ModeloTablaModificarPalabraSinonimos;
import Vista.utiles.UtilidadesComponentes;
import java.awt.Image;
import java.io.File;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;

public class FrmEditarPalabra extends javax.swing.JFrame {

    private File imagen;
    private PalabraDao palabraDao = new PalabraDao();
    private ControladorEjemplo ce = new ControladorEjemplo();
    private ControladorIdiomas ci = new ControladorIdiomas();
    private ControladorSinonimos cs = new ControladorSinonimos();
    private ModeloTablaModificarPalabra mtmp = new ModeloTablaModificarPalabra();
    private ModeloTablaModificarPalabraSinonimos mtmps = new ModeloTablaModificarPalabraSinonimos();
    private ModeloTablaModificarPalabraEjemplos mtmpe = new ModeloTablaModificarPalabraEjemplos();

    /**
     * Creates new form frmPalabras
     */
    public FrmEditarPalabra() {
        initComponents();
        limpiar();
        ordenar();
    }

    /**
     * *
     * Método para ordenar Palabras en la Tabla de FrmEditarPalabra
     */
    private void ordenar() {
        mtmp.setLista(palabraDao.ordenar());
        tblPalabras.setModel(mtmp);
        tblPalabras.updateUI();
    }

    /**
     * *
     * Método para Cargar Tabla Sinónimos
     */
    private void tablaSinonimos() {
        mtmps.setLista(cs.getSinonimos());
        tblSinonimos.setModel(mtmps);
        tblSinonimos.updateUI();
    }

    /**
     * *
     * Método para Cargar Tabla Ejemplos
     */
    private void tablaEjemplos() {
        mtmpe.setLista(ce.getLista());
        tblEjemplos.setModel(mtmpe);
        tblEjemplos.updateUI();
    }

    /**
     * *
     * Método para limpiar los campos del FrmEditarPalabra
     */
    private void limpiar() {
        UtilidadesComponentes.cargarComboIdiomas(cbxIdioma);
        txtDescripcionEjemplos.setText(null);
        cbxIdioma.setSelectedIndex(1);
        txtPalabra.setText(null);
        txtTraduccion.setText(null);
        txtSiglas.setText(null);
        txtSignificado.setText(null);
        txtSinonimo.setText(null);
        lblImagen.setIcon(null);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane2 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        panelNuevaPalabra = new javax.swing.JPanel();
        lblTituloPalabra = new javax.swing.JLabel();
        lblNombrePalabra = new javax.swing.JLabel();
        btnRegistrarPalabra = new javax.swing.JButton();
        lblSinonimo = new javax.swing.JLabel();
        txtSinonimo = new javax.swing.JTextField();
        lblIdioma = new javax.swing.JLabel();
        txtPalabra = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtSignificado = new javax.swing.JTextArea();
        lblSignificado = new javax.swing.JLabel();
        lblEjemplos = new javax.swing.JLabel();
        btnBuscarImagen = new javax.swing.JButton();
        lblDescripcion = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        txtDescripcionEjemplos = new javax.swing.JTextArea();
        lblImagen = new javax.swing.JLabel();
        lblimagen = new javax.swing.JLabel();
        btnRegresar = new javax.swing.JButton();
        lblEditarPalabra = new javax.swing.JLabel();
        lblSiglas = new javax.swing.JLabel();
        txtSiglas = new javax.swing.JTextField();
        btnAgregarEjemplos = new javax.swing.JButton();
        cbxIdioma = new javax.swing.JComboBox<>();
        btnAgregarSinonimo = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        jScrollPane4 = new javax.swing.JScrollPane();
        tblPalabras = new javax.swing.JTable();
        jScrollPane5 = new javax.swing.JScrollPane();
        tblSinonimos = new javax.swing.JTable();
        jScrollPane6 = new javax.swing.JScrollPane();
        tblEjemplos = new javax.swing.JTable();
        btnEliminarEjemplo = new javax.swing.JButton();
        btnEliminarSinonimo = new javax.swing.JButton();
        txtRutaImagen = new javax.swing.JTextField();
        txtTraduccion = new javax.swing.JTextField();

        jScrollPane2.setViewportView(jTree1);

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        getContentPane().setLayout(null);

        panelNuevaPalabra.setLayout(null);

        lblTituloPalabra.setFont(new java.awt.Font("Tempus Sans ITC", 1, 24)); // NOI18N
        lblTituloPalabra.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblTituloPalabra.setText("Editar Palabra");
        panelNuevaPalabra.add(lblTituloPalabra);
        lblTituloPalabra.setBounds(0, 10, 1000, 33);

        lblNombrePalabra.setFont(new java.awt.Font("Tempus Sans ITC", 1, 10)); // NOI18N
        lblNombrePalabra.setText("Palabra:");
        panelNuevaPalabra.add(lblNombrePalabra);
        lblNombrePalabra.setBounds(20, 60, 60, 14);

        btnRegistrarPalabra.setFont(new java.awt.Font("Tempus Sans ITC", 0, 12)); // NOI18N
        btnRegistrarPalabra.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Imagenes/icono_listo.png"))); // NOI18N
        btnRegistrarPalabra.setText("Guardar Cambios");
        btnRegistrarPalabra.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RegistrarNuevaPalabra(evt);
            }
        });
        panelNuevaPalabra.add(btnRegistrarPalabra);
        btnRegistrarPalabra.setBounds(930, 390, 150, 40);

        lblSinonimo.setFont(new java.awt.Font("Tempus Sans ITC", 1, 10)); // NOI18N
        lblSinonimo.setText("Sinónimos:");
        panelNuevaPalabra.add(lblSinonimo);
        lblSinonimo.setBounds(20, 100, 60, 14);

        txtSinonimo.setFont(new java.awt.Font("Tempus Sans ITC", 0, 11)); // NOI18N
        panelNuevaPalabra.add(txtSinonimo);
        txtSinonimo.setBounds(80, 90, 130, 30);

        lblIdioma.setFont(new java.awt.Font("Tempus Sans ITC", 1, 10)); // NOI18N
        lblIdioma.setText("Idioma:");
        panelNuevaPalabra.add(lblIdioma);
        lblIdioma.setBounds(20, 140, 50, 14);

        txtPalabra.setFont(new java.awt.Font("Tempus Sans ITC", 0, 11)); // NOI18N
        panelNuevaPalabra.add(txtPalabra);
        txtPalabra.setBounds(80, 50, 160, 30);

        txtSignificado.setColumns(20);
        txtSignificado.setFont(new java.awt.Font("Tempus Sans ITC", 0, 13)); // NOI18N
        txtSignificado.setRows(5);
        jScrollPane1.setViewportView(txtSignificado);

        panelNuevaPalabra.add(jScrollPane1);
        jScrollPane1.setBounds(20, 190, 410, 70);

        lblSignificado.setFont(new java.awt.Font("Tempus Sans ITC", 1, 10)); // NOI18N
        lblSignificado.setText("Significado");
        panelNuevaPalabra.add(lblSignificado);
        lblSignificado.setBounds(20, 170, 60, 17);

        lblEjemplos.setFont(new java.awt.Font("Tempus Sans ITC", 1, 12)); // NOI18N
        lblEjemplos.setText("Ejemplos");
        panelNuevaPalabra.add(lblEjemplos);
        lblEjemplos.setBounds(10, 270, 60, 20);

        btnBuscarImagen.setFont(new java.awt.Font("Tempus Sans ITC", 0, 11)); // NOI18N
        btnBuscarImagen.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Imagenes/magnifier.png"))); // NOI18N
        btnBuscarImagen.setText("Buscar");
        btnBuscarImagen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BuscarImagen(evt);
            }
        });
        panelNuevaPalabra.add(btnBuscarImagen);
        btnBuscarImagen.setBounds(250, 50, 90, 30);

        lblDescripcion.setFont(new java.awt.Font("Tempus Sans ITC", 1, 10)); // NOI18N
        lblDescripcion.setText("Descripción");
        panelNuevaPalabra.add(lblDescripcion);
        lblDescripcion.setBounds(20, 300, 70, 14);

        txtDescripcionEjemplos.setColumns(20);
        txtDescripcionEjemplos.setFont(new java.awt.Font("Tempus Sans ITC", 0, 13)); // NOI18N
        txtDescripcionEjemplos.setRows(5);
        jScrollPane3.setViewportView(txtDescripcionEjemplos);

        panelNuevaPalabra.add(jScrollPane3);
        jScrollPane3.setBounds(20, 320, 310, 70);

        lblImagen.setAlignmentX(150.0F);
        panelNuevaPalabra.add(lblImagen);
        lblImagen.setBounds(340, 330, 140, 100);

        lblimagen.setFont(new java.awt.Font("Tempus Sans ITC", 1, 11)); // NOI18N
        lblimagen.setText("Imagen");
        panelNuevaPalabra.add(lblimagen);
        lblimagen.setBounds(270, 405, 60, 20);

        btnRegresar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Imagenes/icono_regresa.png"))); // NOI18N
        btnRegresar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAtras(evt);
            }
        });
        panelNuevaPalabra.add(btnRegresar);
        btnRegresar.setBounds(20, 10, 40, 33);

        lblEditarPalabra.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Imagenes/icono_editarPalabra.png"))); // NOI18N
        panelNuevaPalabra.add(lblEditarPalabra);
        lblEditarPalabra.setBounds(1020, 0, 70, 80);

        lblSiglas.setFont(new java.awt.Font("Tempus Sans ITC", 1, 10)); // NOI18N
        lblSiglas.setText("Siglas:");
        panelNuevaPalabra.add(lblSiglas);
        lblSiglas.setBounds(200, 130, 40, 30);

        txtSiglas.setFont(new java.awt.Font("Tempus Sans ITC", 0, 11)); // NOI18N
        txtSiglas.setEnabled(false);
        panelNuevaPalabra.add(txtSiglas);
        txtSiglas.setBounds(240, 130, 90, 30);

        btnAgregarEjemplos.setFont(new java.awt.Font("Tempus Sans ITC", 0, 10)); // NOI18N
        btnAgregarEjemplos.setText("Agregar Ejemplos.");
        btnAgregarEjemplos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AgregarEjemplo(evt);
            }
        });
        panelNuevaPalabra.add(btnAgregarEjemplos);
        btnAgregarEjemplos.setBounds(210, 290, 120, 23);

        cbxIdioma.setFont(new java.awt.Font("Tempus Sans ITC", 0, 11)); // NOI18N
        cbxIdioma.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "1", "2", "3" }));
        cbxIdioma.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Idiomas(evt);
            }
        });
        panelNuevaPalabra.add(cbxIdioma);
        cbxIdioma.setBounds(80, 130, 110, 30);

        btnAgregarSinonimo.setFont(new java.awt.Font("Tempus Sans ITC", 0, 10)); // NOI18N
        btnAgregarSinonimo.setText("Agregar sinónimo");
        btnAgregarSinonimo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AgregarSinonimo(evt);
            }
        });
        panelNuevaPalabra.add(btnAgregarSinonimo);
        btnAgregarSinonimo.setBounds(219, 90, 110, 30);
        panelNuevaPalabra.add(jSeparator1);
        jSeparator1.setBounds(20, 270, 310, 10);

        tblPalabras.setFont(new java.awt.Font("Tempus Sans ITC", 0, 11)); // NOI18N
        tblPalabras.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Nro.", "Palabra", "Significado", "Idioma"
            }
        ));
        tblPalabras.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                MostrarDatos(evt);
            }
        });
        jScrollPane4.setViewportView(tblPalabras);

        panelNuevaPalabra.add(jScrollPane4);
        jScrollPane4.setBounds(490, 50, 530, 150);

        tblSinonimos.setFont(new java.awt.Font("Tempus Sans ITC", 0, 11)); // NOI18N
        tblSinonimos.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Sinónimos"
            }
        ));
        jScrollPane5.setViewportView(tblSinonimos);

        panelNuevaPalabra.add(jScrollPane5);
        jScrollPane5.setBounds(490, 210, 170, 160);

        tblEjemplos.setFont(new java.awt.Font("Tempus Sans ITC", 0, 11)); // NOI18N
        tblEjemplos.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Ejemplos"
            }
        ));
        jScrollPane6.setViewportView(tblEjemplos);

        panelNuevaPalabra.add(jScrollPane6);
        jScrollPane6.setBounds(720, 210, 300, 160);

        btnEliminarEjemplo.setBackground(new java.awt.Color(255, 0, 0));
        btnEliminarEjemplo.setFont(new java.awt.Font("Tempus Sans ITC", 1, 10)); // NOI18N
        btnEliminarEjemplo.setText("X");
        btnEliminarEjemplo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                EliminarEjemplos(evt);
            }
        });
        panelNuevaPalabra.add(btnEliminarEjemplo);
        btnEliminarEjemplo.setBounds(1030, 210, 40, 23);

        btnEliminarSinonimo.setBackground(new java.awt.Color(255, 0, 0));
        btnEliminarSinonimo.setFont(new java.awt.Font("Tempus Sans ITC", 1, 11)); // NOI18N
        btnEliminarSinonimo.setText("X");
        btnEliminarSinonimo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                EliminarSinonimos(evt);
            }
        });
        panelNuevaPalabra.add(btnEliminarSinonimo);
        btnEliminarSinonimo.setBounds(670, 210, 40, 23);

        txtRutaImagen.setFont(new java.awt.Font("Tempus Sans ITC", 0, 11)); // NOI18N
        txtRutaImagen.setEnabled(false);
        panelNuevaPalabra.add(txtRutaImagen);
        txtRutaImagen.setBounds(20, 400, 240, 30);

        txtTraduccion.setFont(new java.awt.Font("Tempus Sans ITC", 0, 11)); // NOI18N
        txtTraduccion.setEnabled(false);
        panelNuevaPalabra.add(txtTraduccion);
        txtTraduccion.setBounds(350, 50, 130, 30);

        getContentPane().add(panelNuevaPalabra);
        panelNuevaPalabra.setBounds(0, 0, 1090, 440);

        setSize(new java.awt.Dimension(1108, 477));
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void btnAtras(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAtras
        this.dispose();
    }//GEN-LAST:event_btnAtras

    private void buscadorPalabra() {
        mtmp.setLista(palabraDao.buscar(txtPalabra.getText().trim()));
        tblPalabras.setModel(mtmp);
        tblPalabras.updateUI();
    }

    private void BuscarImagen(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BuscarImagen
        buscadorPalabra();
    }//GEN-LAST:event_BuscarImagen

    /**
     * *
     * Método para guardar cambios realizados en FrmEditarPalabra
     */
    private void guardarCambios() {
        if (txtPalabra.getText().trim().length() > 0) {
            
            palabraDao.setPalabraAux(null);
            palabraDao.getPalabraAux().setNombrePalabra(txtPalabra.getText().trim());
            palabraDao.getPalabraAux().setTraduccion(txtTraduccion.getText().trim());
            palabraDao.getPalabraAux().setSinonimo(cs.getSinonimos());
            ci.agregarIdiomas();
            palabraDao.getPalabraAux().setIdiomas(ci.getLista());
            palabraDao.getPalabraAux().setSignificado(txtSignificado.getText().trim());
            palabraDao.getPalabraAux().setEjemplos(ce.getLista());
            palabraDao.getPalabraAux().setImagen(txtRutaImagen.getText());

            if (palabraDao.getPalabra().getNombrePalabra() != null) {
                if (palabraDao.modificar(palabraDao.getPalabraAux())) {
                    JOptionPane.showMessageDialog(this, "Los cambios se ha guardado correctamente");
                    limpiar();
                    ordenar();
                } else {
                    JOptionPane.showMessageDialog(this, "No se han guardado los cambios");
                }
            }
        } else {
            JOptionPane.showMessageDialog(this, "No hay que modificar");
        }
    }

    private void RegistrarNuevaPalabra(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RegistrarNuevaPalabra
        if (!txtPalabra.getText().trim().isEmpty() && !txtTraduccion.getText().trim().isEmpty()
            && !txtSignificado.getText().trim().isEmpty()) {
            guardarCambios();
        } else {
            JOptionPane.showMessageDialog(this, "Existen Importantes sin llenar");
        }
    }//GEN-LAST:event_RegistrarNuevaPalabra

    /**
     * *
     * Método para guardar ejemplos en FrmEditarPalabra
     */
    private void guardarEjemplos() {
        ce.setEjemplo(null);
        ce.getEjemplo().setId(String.valueOf((int) (Math.random() * 100)));
        ce.getEjemplo().setDescripcion(txtDescripcionEjemplos.getText().trim());
        ce.guardarEjemplos(ce.getEjemplo());
    }

    private void AgregarEjemplo(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AgregarEjemplo
        if (!txtDescripcionEjemplos.getText().trim().isEmpty()) {
            guardarEjemplos();
            txtDescripcionEjemplos.setText(null);
            tablaEjemplos();
        } else {
            JOptionPane.showMessageDialog(this, "El campo Descripción de Ejemplo está vacío", "Campo Vacío", 2);
        }
    }//GEN-LAST:event_AgregarEjemplo

    /**
     * *
     * Método para guardar sinónimos en FrmEditarPalabra
     */
    private void guardarSinonimos() {
        cs.setSinonimo(null);
        cs.setSinonimo(txtSinonimo.getText().trim());
        cs.guardarSinonimo(cs.getSinonimo());
    }

    private void AgregarSinonimo(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_AgregarSinonimo
        if (!txtSinonimo.getText().trim().isEmpty()) {
            guardarSinonimos();
            txtSinonimo.setText(null);
            tablaSinonimos();
        } else {
            JOptionPane.showMessageDialog(this, "El campo Sinónimo está vacío", "Campo Vacío", 2);
        }
    }//GEN-LAST:event_AgregarSinonimo

    private void Idiomas(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Idiomas
        if (!txtPalabra.getText().trim().isEmpty()) {
            if (String.valueOf(cbxIdioma.getSelectedItem()).equals(String.valueOf(Idiomas.Espanol))) {
                txtSiglas.setText(SiglasIdiomas.ES.toString());
            }
            if (String.valueOf(cbxIdioma.getSelectedItem()).equals(String.valueOf(Idiomas.Ingles))) {
                txtSiglas.setText(SiglasIdiomas.EN.toString());
            }
        }
    }//GEN-LAST:event_Idiomas

    private void MostrarDatos(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_MostrarDatos
        int aux = tblPalabras.getSelectedRow();
        String auxPal = String.valueOf(tblPalabras.getValueAt(aux, 1));
        palabraDao.setPalabra(null);
        palabraDao.setPalabra(palabraDao.buscarUnaPalabra(auxPal));
        txtPalabra.setText(palabraDao.getPalabra().getNombrePalabra());
        txtTraduccion.setText(palabraDao.getPalabra().getTraduccion());
        txtSignificado.setText(palabraDao.getPalabra().getSignificado());
        cs.setSinonimos(palabraDao.getPalabra().getSinonimo());
        ce.setLista(palabraDao.getPalabra().getEjemplos());
        txtRutaImagen.setText(palabraDao.getPalabra().getImagen());
        try {
            ImageIcon ImgIcon = new ImageIcon(txtRutaImagen.getText());
            Icon icono = new ImageIcon(ImgIcon.getImage().getScaledInstance(lblImagen.getWidth(), lblImagen.getHeight(), Image.SCALE_DEFAULT));
            lblImagen.setIcon(icono);

        } catch (Exception e) {
            JOptionPane.showMessageDialog(this, "Error al abrir: " + e);
        }
        tablaSinonimos();
        tablaEjemplos();
    }//GEN-LAST:event_MostrarDatos

    private void EliminarEjemplos(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_EliminarEjemplos
        int aux = -1;
        aux = tblEjemplos.getSelectedRow();
        ce.getLista().EliminarDato(ce.buscarEjemplo(String.valueOf(tblEjemplos.getValueAt(aux, 0))));
        tablaEjemplos();
    }//GEN-LAST:event_EliminarEjemplos

    private void EliminarSinonimos(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_EliminarSinonimos
        int aux = -1;
        aux = tblSinonimos.getSelectedRow();
        cs.getSinonimos().EliminarDato(String.valueOf(tblSinonimos.getValueAt(aux, 0)));
        tablaSinonimos();
    }//GEN-LAST:event_EliminarSinonimos

    /**
     * *
     * Método para Cargar la imagen de una Palabra en FrmEditarPalabra
     */
    private void BuscarCargarImagenEjemplo() {
        int resultado;
        FrmBuscadorImagenes buscador = new FrmBuscadorImagenes();
        FileNameExtensionFilter formato = new FileNameExtensionFilter("JPG, PNG y GIT", "jpg", "img", "git");
        buscador.jfcImg.setFileFilter(formato);
        resultado = buscador.jfcImg.showOpenDialog(null);

        if (JFileChooser.APPROVE_OPTION == resultado) {
            imagen = buscador.jfcImg.getSelectedFile();
            try {
                ImageIcon ImgIcon = new ImageIcon(imagen.toString());
                Icon icono = new ImageIcon(ImgIcon.getImage().getScaledInstance(lblImagen.getWidth(), lblImagen.getHeight(), Image.SCALE_DEFAULT));
                lblImagen.setIcon(icono);
            } catch (Exception e) {
                JOptionPane.showMessageDialog(this, "Error al abrir: " + e);
            }
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(FrmEditarPalabra.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(FrmEditarPalabra.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(FrmEditarPalabra.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(FrmEditarPalabra.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new FrmEditarPalabra().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAgregarEjemplos;
    private javax.swing.JButton btnAgregarSinonimo;
    private javax.swing.JButton btnBuscarImagen;
    private javax.swing.JButton btnEliminarEjemplo;
    private javax.swing.JButton btnEliminarSinonimo;
    private javax.swing.JButton btnRegistrarPalabra;
    private javax.swing.JButton btnRegresar;
    private javax.swing.JComboBox<String> cbxIdioma;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JTree jTree1;
    private javax.swing.JLabel lblDescripcion;
    private javax.swing.JLabel lblEditarPalabra;
    private javax.swing.JLabel lblEjemplos;
    private javax.swing.JLabel lblIdioma;
    private javax.swing.JLabel lblImagen;
    private javax.swing.JLabel lblNombrePalabra;
    private javax.swing.JLabel lblSiglas;
    private javax.swing.JLabel lblSignificado;
    private javax.swing.JLabel lblSinonimo;
    private javax.swing.JLabel lblTituloPalabra;
    private javax.swing.JLabel lblimagen;
    private javax.swing.JPanel panelNuevaPalabra;
    private javax.swing.JTable tblEjemplos;
    private javax.swing.JTable tblPalabras;
    private javax.swing.JTable tblSinonimos;
    private javax.swing.JTextArea txtDescripcionEjemplos;
    private javax.swing.JTextField txtPalabra;
    private javax.swing.JTextField txtRutaImagen;
    private javax.swing.JTextField txtSiglas;
    private javax.swing.JTextArea txtSignificado;
    private javax.swing.JTextField txtSinonimo;
    private javax.swing.JTextField txtTraduccion;
    // End of variables declaration//GEN-END:variables
}
